stages:
  - static
  - functional
  - publish

variables:
  ENV: CI

.python:
  image: registry.access.redhat.com/ubi8/python-39:1-97.1674497503
  before_script:
    - make depend a="test"

build:
  extends: .python
  stage: static
  before_script:
    - make depend a="test"
  script:
    - make build
  artifacts:
    paths:
      - dist/
    expire_in: 1 hour
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
      when: always
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      when: always
      variables:
        ENV: PROD

precommit:
  image: python:3.11.1
  stage: static
  before_script:
    - apt update && apt install -y rubygems
    - export POETRY_HOME="/opt/poetry"
    - export PATH="$POETRY_HOME/bin:$PATH"
    - make depend a="precommit"
  script:
    - make precommit
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
      when: always
    - if: "$CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH"
      when: never

unit:
  extends: .python
  stage: static
  script:
    - make unit
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
      when: always
    - if: "$CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH"
      when: never

functional:
  image: docker:20.10.24
  services:
    - docker:20.10.24-dind
  stage: functional
  before_script:
    - apk add --update make curl gcc python3-dev musl-dev py3-pip
    - export POETRY_HOME="/opt/poetry"
    - export PATH="$POETRY_HOME/bin:$PATH"
    - make depend a="test"
  script:
    - make up publish functional
  parallel:
    matrix:
      - PYTHONVER: ["3.7", "3.9.7", "3.10.7"]
  needs: ["build"]
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
      when: always
    - if: "$CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH"
      when: never

publish:
  extends: .python
  stage: publish
  script:
    - make publish
  needs: ["build"]
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
      when: never
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      when: manual
      variables:
        ENV: PROD
